<script setup lang="ts">
import { ref, onMounted } from 'vue';
import { useReceiptStore } from '@/stores/receipt';
import type { HistoryItem } from '@/types/ReceiptHistory';

const receiptStore = useReceiptStore();

const receiptHistory = ref(receiptStore.receiptHistory);

const receiptHeaders = [
  { title: 'ID', value: 'id' },
  { title: 'Date', value: 'Date' },
  { title: 'Time', value: 'Time' },
  { title: 'Total Before', value: 'totalBefore' },
  { title: 'Member Discount', value: 'memberDiscount' },
  { title: 'Total', value: 'total' },
  { title: 'Amount', value: 'receivedAmount' },
  { title: 'Received Amount', value: 'receivedAmount' }, // Updated header
  { title: 'Change', value: 'change' },
  { title: 'Payment Type', value: 'paymentType' },
  { title: 'Member ID', value: 'memberId' },
  { title: 'Actions', value: 'actions', sortable: false },
];

const initialReceiptHistory: HistoryItem = {
  id: 0,
  createDate: new Date(),
  totalBefore: 0,
  memberDiscount: 0,
  total: 0,
  receivedAmount: 0,
  change: 0,
  paymentType: '',
  userId: 0,
  memberId: 0,
  items: []
};

onMounted(() => {
  initializeReceiptHistory();
});

function initializeReceiptHistory() {
  receiptHistory.value = receiptStore.receiptHistory;
}
const confirmDeleteReceipt = (item: HistoryItem) => {
  if (window.confirm('Are you sure you want to delete this receipt?')) {
    deleteReceipt(item);
  }
};
function deleteReceipt(item: HistoryItem) {
  const index = receiptHistory.value.indexOf(item);

  // If the item is found, remove it
  if (index !== -1) {
    receiptHistory.value.splice(index, 1);
  }
}
function viewReciept(item: HistoryItem) {
  const index = receiptHistory.value.indexOf(item)
  console.log(receiptHistory.value[index].items)
}
const formatDate = (date: Date) =>
  date.toLocaleDateString('th-TH', {
    year: '2-digit',
    month: '2-digit',
    day: '2-digit'
  })
const formatTime = (date: Date) => date.toLocaleTimeString('th-TH')

// Reactive references
const currentDate = ref(new Date())

const formattedDate = (d: Date) => {
  return formatDate(d)
}
const formattedTime = (t: Date) => {
  return formatTime(t)
}
</script>

<template>
  <div>
    <v-data-table :headers="receiptHeaders" style="background-color: rgba(202, 174, 123, 0.582);" :items="receiptStore.receiptHistory">
      <template v-slot:top>
        <v-toolbar flat style="background-color: rgba(82, 72, 54, 0.842);">
          <v-toolbar-title style="color: rgb(255, 255, 255);"><v-icon>mdi-history</v-icon> Receipt History </v-toolbar-title>
          <v-divider class="mx-4" inset vertical color="blue darken-2"></v-divider>
        </v-toolbar>
      </template>
      <template v-slot:item="{ item }">
        <tr>
          <td>{{ item.id }}</td>
          <td>{{ formatDate(item.createDate) }}</td>
          <td>{{ formatTime(item.createDate) }}</td>
          <td>{{ item.totalBefore }}</td>
          <td>{{ item.memberDiscount }}</td>
          <td>{{ item.total }}</td>
          <td>{{ item.receivedAmount }}</td>
          <td>{{ item.change }}</td>
          <td>{{ item.paymentType }}</td>
          <td>{{ item.userId }}</td>
          <td>{{ item.memberId }}</td>
          <td>
            <v-dialog width="800">
              <template v-slot:activator="{ props }">
                <v-icon v-bind="props" text="view">mdi-eye-outline</v-icon>
              </template>

              <template v-slot:default="{ isActive }">
                <v-card>
                  <v-card-text style="font-size: 22pt;">Reciept History Info <v-icon>mdi-history</v-icon></v-card-text>
                  <v-card-text>
                    Cashier : {{ item.user?.fullname }} <br />
                    Date : {{ formatDate(item.createDate) }} <br />
                    Time : {{ formatTime(item.createDate) }} <br>
                    Member ID:
                    <span v-if="item.memberId == 0" style="color: red;">Not Member</span>
                    <span v-else style="color: green;">{{ item.memberId }}</span>
                  </v-card-text>
                  <v-table>
                      <thead>
                      <tr style="text-align: center">
                        <th>ID</th>
                        <th>ProductName</th>
                        <th>Price(Bath)</th>
                        <th>Unit</th>
                      </tr>
                    </thead>
                    <tbody style="padding: 30px">
                      <tr style="align-self: center" v-for="(item1, index) in item.items" :key="index">
                        <td>{{ index+1 }}</td>
                        <td>{{ item1.name }}</td>
                        <td>{{ item1.price }}</td>
                        <td>{{ item1.unit }}</td>
                      </tr>
                      <tr style="align-self: center">
                        <td>Subtotal</td>
                        <td></td>
                        <td>{{ item.totalBefore }}</td>
                        <td></td>
                      </tr>
                      <tr style="align-self: center">
                        <td>Total</td>
                        <td></td>
                        <td>{{ item.total }}</td>
                        <td></td>
                      </tr>
                    </tbody>
                  </v-table>
                  <v-card-text>

                  </v-card-text>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn text="Close" @click="isActive.value = false"></v-btn>
                  </v-card-actions>
                </v-card>
              </template>
            </v-dialog>
            <v-icon @click="confirmDeleteReceipt(item)">mdi-delete</v-icon>
          </td>
        </tr>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="initializeReceiptHistory">Reset</v-btn>
      </template>
    </v-data-table>
  </div>
</template>